//+------------------------------------------------------------------+
//|                                                      MA_Move.mq4 |
//|                                                          Kevin A |
//|                                     Coded by Santhosh44 @ Elance |
//+------------------------------------------------------------------+
#property copyright "Kevin A"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 0

extern int     EMAPeriod         = 50;
extern int     TargetMove        = 10;
extern color   UpMoveLine        = DodgerBlue;
extern color   DownMoveLine      = Magenta;
extern bool    PopupAlert        = true;
extern bool    SoundAlert        = false;
extern string  AlertFile         = "alert2.wav";

double myPoint;
int lastbuy, lastsell;
string msg;
int ulcount, dlcount;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   if(Digits==3 || Digits==5) {
      myPoint = 10 * Point;
   }  else {
      myPoint = Point;
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   for(int i = 1; i <= ulcount ; i++)
      ObjectDelete("UPLINE"+i);
   for(i = 1; i <= dlcount ; i++)
      ObjectDelete("DOWNLINE"+i);

   //Comment("");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
   if(counted_bars < 0) return(-1);

   msg = "Indicator active..."+"\n" ;
   for(int i = 0 ; i < Bars ; i++) {
      double ema = iMA(NULL, 0, EMAPeriod, 0, MODE_EMA, PRICE_CLOSE, i);   
      if((High[i] > ema && Low[i] <= ema) || (Low[i] < ema && High[i] >= ema))
         break;
   }            
   msg = msg + "Last EMA("+EMAPeriod+") touch - Time @ "+TimeToStr(Time[i])+", Ema @ "+DoubleToStr(ema,Digits)+"\n";
   
   if(High[0] >= ema + TargetMove*myPoint) {
      bool movecompleted = false;
      movecompleted = i > 0 && High[iHighest(NULL, 0, MODE_HIGH,i,1)] >= ema + TargetMove*myPoint;
      if(!movecompleted && lastbuy != Bars) {
         if(PopupAlert)
            Alert(Symbol()+" "+GetTFAsString(Period())+" : "+ TargetMove + " pips UP Move after EMA("+EMAPeriod+") touch..");
         if(SoundAlert)
            PlaySound(AlertFile);
         lastbuy = Bars;
         ulcount++;
         DrawVLine("UPLINE"+ulcount,Time[0],UpMoveLine);
      }
   } else if(Low[0] < ema - TargetMove*myPoint) {
      movecompleted = false;
      movecompleted = i > 0 && Low[iLowest(NULL, 0, MODE_LOW,i,1)] <= ema - TargetMove*myPoint;
      if(!movecompleted && lastsell != Bars) {
         if(PopupAlert)
            Alert(Symbol()+" "+GetTFAsString(Period())+" : "+ TargetMove + " pips DOWN Move after EMA("+EMAPeriod+") touch..");
         if(SoundAlert)
            PlaySound(AlertFile);
         lastsell = Bars;
         dlcount++;
         DrawVLine("DOWNLINE"+dlcount,Time[0],DownMoveLine);
      }
   }
   
   Comment(msg);
   return(0);
  }
//+------------------------------------------------------------------+

void DrawVLine(string name, datetime time,color col)
{
   ObjectCreate(name, OBJ_VLINE, 0, time, 0);
   ObjectSet(name,OBJPROP_COLOR,col);
   ObjectSet(name,OBJPROP_WIDTH,1);
   ObjectSet(name,OBJPROP_STYLE,STYLE_DOT);
}

string GetTFAsString(int tf)
{
   switch(tf) {
      case PERIOD_M1:
         return("M1") ;
         break;
      case PERIOD_M5:
         return("M5") ;
         break;
      case PERIOD_M15:
         return("M15") ;
         break;
      case PERIOD_M30:
         return("M30") ;
         break;
      case PERIOD_H1:
         return("H1") ;
         break;
      case PERIOD_H4:
         return("H4") ;
         break;
      case PERIOD_D1:
         return("D1") ;
         break;
   }
}